#
# spec file for package kernel-iseries64
#
# Copyright (c) 2015 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%define build_kdump %(case iseries64 in (kdump*) echo 1;; (*) echo 0;; esac)
%define build_xen %(case iseries64 in (xen*) echo 1;; (*) echo 0;; esac)
%define build_um  %([ iseries64 != um ] ; echo $?)

Name:           kernel-iseries64
%if ! 0%{?opensuse_bs}
BuildRequires:  kernel-dummy
%endif

%ifarch ia64
# arch/ia64/scripts/unwcheck.py
BuildRequires:  python
%endif
%ifarch %ix86 x86_64 ppc ppc64 ia64
BuildRequires:  makedumpfile
%endif
Version:        2.6.16.60
Release:        0.132.1
Summary:        64-Bit Kernel for iSeries
License:        core kernel and most modules are GPL, some proprietary
Group:          System/Kernel
%if %build_um
#Conflicts:    kernel
%else
Provides:       kernel = 2.6.16.60-%release
%endif
Provides:       kernel-iseries64-nongpl
Obsoletes:      kernel-iseries64-nongpl
%ifarch %ix86
Conflicts:      libc.so.6()(64bit)
%endif
%ifarch ppc
%else
%ifarch ppc64
%endif
%endif
%ifarch %ix86 x86_64
%if "iseries64" != "default" && "iseries64" != "kdump" && "iseries64" != "kdumppae"
Requires:       irqbalance
%endif
%endif
%ifarch ia64
%if "iseries64" == "default"
Requires:       irqbalance
%endif
%endif
Provides:       filesystem(autofs5)
Conflicts:      apparmor-profiles <= 2.0-34
Conflicts:      apparmor-parser <= 2.1.1-0.1
AutoReqProv:    on
%define my_builddir %_builddir/%{name}-%{version}
Source0:        http://www.kernel.org/pub/linux/kernel/v2.6/linux-2.6.16.tar.bz2
Source1:        functions.sh
Source11:       postun.sh
Source12:       post.sh
Source13:       pre.sh
Source20:       series.conf
Source21:       config.conf
Source22:       supported.conf
Source30:       arch-symbols
Source31:       guards
Source32:       config-subst
Source33:       check-for-config-changes
Source34:       check-supported-list
Source35:       install-configs
Source40:       build-source-timestamp
Source41:       built-in-where
Source42:       symsets.pl
Source43:       find-provides
Source45:       module-renames
Source46:       modversions
Source47:       modprobe.d-qeth
Source48:       generic_serial-blacklist
Source100:      config.tar.bz2
Source101:      patches.arch.tar.bz2
Source102:      patches.drivers.tar.bz2
Source103:      patches.fixes.tar.bz2
Source104:      patches.rpmify.tar.bz2
Source105:      patches.suse.tar.bz2
Source106:      patches.xfs.tar.bz2
Source107:      patches.uml.tar.bz2
Source108:      patches.xen.tar.bz2
Source109:      patches.addon.tar.bz2
Source110:      patches.kernel.org.tar.bz2
Source111:      patches.vmi.tar.bz2
Source112:      patches.apparmor.tar.bz2
Source120:      kabi.tar.bz2
PreReq:         mkinitrd >= 1.2
PreReq:         coreutils
# This PreReq is wrong, because the post/postun scripts have a
# test -x updatebootloader, having perl-Bootloader is not a hard requirement.
# But, there is no way to tell rpm or yast to schedule the installation
# of perl-Bootloader before kernel-binary.rpm if both are in the list of
# packages to install/update.
# A specific version of perl-Bootloader is not required, because the post/postun
# scripts handle the two API versions of 10.1/SLES10 GA and 10.2/SLES10 SP1
PreReq:         perl-Bootloader
PreReq:         rpm
#!BuildIgnore: irqbalance xen
#!BuildIgnore: perl-Bootloader mkinitrd
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch:  ppc ppc64

# These files are found in the kernel-source package:
NoSource:       0
NoSource:       100
NoSource:       101
NoSource:       102
NoSource:       103
NoSource:       104
NoSource:       105
NoSource:       106
NoSource:       107
NoSource:       108
NoSource:       109
NoSource:       110
NoSource:       111
NoSource:       112
NoSource:       120

# The following KMPs have been integrated into the kernel package. (We add
# "a" to the versions here to ignore the kernel version, which is part of
# the KMP version, i.e., 7.3.15_2.6.16.21_0.8)
Obsoletes:      adaptec-aacraid-kmp-iseries64 < 1.1.5.2459a
Obsoletes:      adaptec-aic94xx-kmp-iseries64 < 1.0.2a
Obsoletes:      atheros-atl1-kmp-iseries64 < 1.2.40.3a
Obsoletes:      broadcom-bnx2-kmp-iseries64 < 2.0.1a
Obsoletes:      broadcom-bnx2x-kmp-iseries64 < 1.48.105a
Obsoletes:      broadcom-tg3-kmp-iseries64 < 3.99ca
Obsoletes:      brocade-bfa-kmp-iseries64 < 2.0.0.0a
Obsoletes:      brocade-bna-kmp-iseries64 < 2.0.0.0a
Obsoletes:      dell-sata_svw-kmp-iseries64 < 2.0.1a
Obsoletes:      fsc-benet <= 1.0.748.0-2
Obsoletes:      fsc-benet-kmp-iseries64 < 1.0.748.0_2.6.16.60_0.47
Obsoletes:      fsc-e1000e <= 0.4.1.7-1
Obsoletes:      fsc-e1000e-kmp-iseries64 < 0.4.1.7_2.6.16.60_0.47
Obsoletes:      fsc-igb <= 1.3.8.6-1
Obsoletes:      fsc-igb-kmp-iseries64 < 1.2.44.3_2.6.16.60_0.47
Obsoletes:      fsc-ixgbe <= 1.3.31.5-1
Obsoletes:      fsc-ixgbe-kmp-iseries64 < 1.3.31.5_2.6.16.60_0.47
Obsoletes:      fsc-lpfc <= 8.1.10.3.3fsc-3
Obsoletes:      fsc-megaraid <= 2.20.5.0.3fsc-1
Obsoletes:      fsc-megaraid_sas-kmp-iseries64 < 00.00.03.23a
Obsoletes:      fsc-sky2-kmp-iseries64 < 1.10a
Obsoletes:      fsc-tg3-kmp-iseries64 < 3.77d
Obsoletes:      fujitsujp-e1000-kmp-iseries64 < 7.6.9.1a
Obsoletes:      fujitsujp-fusion < 3.03.16FJ1.0a
Obsoletes:      fujitsujp-fusion-kmp-iseries64 < 3.04.02FJ1.0
Obsoletes:      fujitsujp-lpfc < 8.1.6FJ1.0a
Obsoletes:      fujitsujp-lpfc-kmp-iseries64 < 8.1.10.10FJ1.0
Obsoletes:      fujitsujp-pciehp-kmp-iseries64 < 0.4FJ2.0.1a
Obsoletes:      hp-e1000-kmp-iseries64 < 7.6.5a
Obsoletes:      hp-qla2xxx-kmp-iseries64 < 8.01.07.25
Obsoletes:      hp-r8101-kmp-iseries64 < 1.009.00a
Obsoletes:      hp-sky2-kmp-iseries64 < 1.22a
Obsoletes:      ibm-aacraid-kmp-iseries64 < 1.1.5.2449
Obsoletes:      intel-e1000-kmp-iseries64 < 7.6.15.6a
Obsoletes:      intel-e1000e-kmp-iseries64 < 1.0.2.5a
Obsoletes:      intel-hda-codec-kmp-iseries64 < 1.0a
Obsoletes:      intel-i810-agpgart-kmp-iseries64 < 1.2
Obsoletes:      intel-i810-drm < 1.2
Obsoletes:      intel-iamt-heci-kmp-iseries64 < 3.1.0.31
Obsoletes:      intel-igb-kmp-iseries64 < 1.3.19.3a
Obsoletes:      intel-ipw3945-kmp-iseries64 < 1.1.0a
Obsoletes:      intel-iwlwifi-kmp-iseries64 < 1.3.27a
Obsoletes:      intel-ixgbe-kmp-iseries64 < 2.0.34.3a
Obsoletes:      lpfc-kmp-iseries64 < 8.2.0.29a
Obsoletes:      lsi-megaraid_sas-kmp-iseries64 < 00.00.03.15
Obsoletes:      lsi-mptlinux-kmp-iseries64 < 4.00.43.00a
Obsoletes:      novell-mac80211-kmp-iseries64 < 20081028a
Obsoletes:      novell-sky2-kmp-iseries64 < 1.22a
Obsoletes:      primergy-benet <= 1.0.748.0-2
Obsoletes:      primergy-benet-kmp-iseries64 < 1.0.748.0_2.6.16.60_0.47
Obsoletes:      primergy-e1000e <= 0.4.1.7-1
Obsoletes:      primergy-e1000e-kmp-iseries64 < 0.4.1.7_2.6.16.60_0.47
Obsoletes:      primergy-igb <= 1.3.8.6-1
Obsoletes:      primergy-igb-kmp-iseries64 < 1.2.44.3_2.6.16.60_0.47
Obsoletes:      primergy-ixgbe <= 1.3.31.5-1
Obsoletes:      primergy-ixgbe-kmp-iseries64 < 1.3.31.5_2.6.16.60_0.47
Obsoletes:      qlogic-qla2xxx-kmp-iseries64 < 8.01.07.ks
Obsoletes:      qlogic-qla2xxx-kmp-iseries64 < 8.01.07a
Obsoletes:      realtek-r8169-kmp-iseries64 < 8.008.00a
Obsoletes:      sgi-fusion-kmp-iseries64 < 3.04.02a
Obsoletes:      tg3-kmp-iseries64 <= 3.110
Obsoletes:      netxtreme2-kmp-iseries64 <= 6.2.6
Obsoletes:      e1000-kmp-iseries64 <= 8.0.23
Obsoletes:      e1000e-kmp-iseries64 <= 1.2.20
Obsoletes:      igb-kmp-iseries64 <= 2.4.8
Obsoletes:      nx_nic-kmp-iseries64 <= 4.0.539
Obsoletes:      be2net-kmp-iseries64 <= 2.102.514.0
Obsoletes:      mlnx-kmp-iseries64 <= 1.5.5.7
Obsoletes:      hp-cciss-kmp-iseries64 <= 3.6.36_3
Obsoletes:      primergy-megaraid_sas-kmp-iseries64 <= 00.00.04.31_3
Obsoletes:      primergy-ixgbe-kmp-iseries64 <= 2.0.75.7_3
Obsoletes:      primergy-lpfc-kmp-iseries64 <= 8.2.0.76.3fts_3
Obsoletes:      primergy-igb-kmp-iseries64 <= 2.2.9_3
Obsoletes:      primergy-be2net-kmp-iseries64 <= 2.102.348.0_3
Obsoletes:      primergy-e1000e-kmp-iseries64 <= 1.1.2_3
Obsoletes:      broadcom-bnx2x-kmp-iseries64 <= 1.50.22_3
Obsoletes:      elx-lpfc-kmp-iseries64 <= 8.2.0.85_3
Obsoletes:      hp-cciss-kmp-iseries64 <= 3.6.20_3
Obsoletes:      hp-bnx2x-kmp-iseries64 <= 1.52.12_3
Obsoletes:      intel-e1000-kmp-iseries64 <= 8.0.19_3
Obsoletes:      intel-e1000e-kmp-iseries64 <= 1.1.2.1_3
Obsoletes:      intel-igb-kmp-iseries64 <= 2.2.9_3
Obsoletes:      intel-ixgbe-kmp-iseries64 <= 3.0.14_3
Obsoletes:      intel-ixgbevf-kmp-iseries64 <= 1.0.9_3
Obsoletes:      lsi-mptlinux-kmp-iseries64 <= 4.00.43.00_3
Obsoletes:      lsi-megraid_sas-kmp-iseries64 <= 00.00.04.38_3
Obsoletes:      qlgc-netxen_nic-kmp-iseries64 <= 4.0.74_3
Obsoletes:      netxen-netxen_nic-kmp-iseries64 <= 4.0.72_3
Obsoletes:      qlogic-qla2xxx-kmp-iseries64 <= 8.03.00.14.10.3.k4_3

# Provide the exported symbols as "ksym(symbol) = hash"
%define __find_provides %_sourcedir/find-provides %name

# Will modules not listed in supported.conf abort the kernel build (0/1)?
%define supported_modules_check 0

%define tolerate_unknown_new_config_options 0

# kABI change tolerance (default in maintenance should be 4, 6, 8 or 15;
# see scripts/kabi-checks)
%define tolerate_kabi_changes 6

%(chmod +x %_sourcedir/{arch-symbols,guards,config-subst,check-for-config-changes,check-supported-list,built-in-where,find-provides,symsets.pl,modversions,install-configs})

%description
Standard 64-bit kernel for legacy IBM iSeries machines.

Source Timestamp: 2015-03-05 10:07:41 +0100
GIT Revision: afc1df513f0e61aaa8885596b969636d882356c1
GIT Branch: SLES10-SP4-LTSS

%prep
if ! [ -e %_sourcedir/linux-2.6.16.tar.bz2 ]; then
    echo "The kernel-iseries64-2.6.16.60.nosrc.rpm package does not contain the" \
	 "complete sources. Please install kernel-source-2.6.16.60.src.rpm."
    exit 1
fi

symbols=$(
    echo kernel-iseries64
    cd %_sourcedir
    PATCH_ARCH=%_target_cpu ./arch-symbols
    ! [ -e extra-symbols ] || cat extra-symbols
)
echo "Architecture symbol(s):" $symbols

# Unpack all sources and patches
%setup -q -c -T -a 0 -a 100 -a 101 -a 102 -a 103 -a 104 -a 105 -a 106 -a 107 -a 108 -a 109 -a 110 -a 111 -a 112 -a 120

# Generate the list of supported modules
(   %_sourcedir/guards $symbols < %_sourcedir/supported.conf
    for how in external; do
	(   %_sourcedir/guards $symbols < %_sourcedir/supported.conf
	    %_sourcedir/guards $symbols < %_sourcedir/supported.conf
	    %_sourcedir/guards $symbols $how < %_sourcedir/supported.conf \
	) | sort | uniq -u | sed -e 's:$: '"$how"':'
    done
) | sed -e 's,.*/,,' | sort > linux-2.6.16/Module.supported

cd linux-2.6.16

# Find out for which architecture to build. We do this here, and use the
# result in the %build and %install sections.
#
# On architectures with a bi-arch or cross compiler, we can compile for
# an architecture different from %arch. The location of the config file
# tells us for which architecture to compile.
set -- $(
    for config in $(%_sourcedir/guards $symbols < %_sourcedir/config.conf) ; do
	[ ${config#*/} = iseries64 ] && echo $config
    done)
if [ $# -ne 1 ]; then
    echo "$# config files found for this spec file (but one needed)" >&2
    exit 1
fi
subarch=${1%/*}

# Apply the patches needed for this architecture.
for patch in $(%_sourcedir/guards $symbols < %_sourcedir/series.conf); do
    if ! patch -s -F0 -E -p1 --no-backup-if-mismatch -i ../$patch; then
	echo "*** Patch $patch failed ***"
	exit 1
    fi
done

%_sourcedir/install-configs %_sourcedir %my_builddir %release
config=arch/$subarch/defconfig.iseries64
cat $config \
%if %{defined __debug_package}
    | %_sourcedir/config-subst CONFIG_DEBUG_INFO y \
%endif
    > .config

# We compile for this sub-architecture (i.e., machine architecture):
%if %build_um
cat > ../.rpm-defs <<EOF
ARCH=iseries64
SUBARCH=$subarch
MAKE_ARGS="ARCH=iseries64 SUBARCH=$subarch"
EOF
%else
cat > ../.rpm-defs <<EOF
ARCH=$subarch
SUBARCH=$subarch
MAKE_ARGS="ARCH=$subarch"
EOF
%endif

%if %{defined __debug_package}
cat >> ../.rpm-defs <<EOF
MAKE_ARGS="\$MAKE_ARGS CONFIG_DEBUG_INFO=y"
EOF
%endif

%build
source .rpm-defs

cd linux-2.6.16
cp .config .config.orig
%if %{tolerate_unknown_new_config_options}
MAKE_ARGS="$MAKE_ARGS -k"
yes '' | make oldconfig $MAKE_ARGS
%else
make silentoldconfig $MAKE_ARGS < /dev/null
%_sourcedir/check-for-config-changes .config.orig .config
rm .config.orig
%endif

# create *.symref files in the tree
if [ -e ../kabi/$SUBARCH/symtypes-iseries64 ]; then
    %_sourcedir/modversions --unpack . <../kabi/$SUBARCH/symtypes-iseries64
fi

KERNELRELEASE=$(make -s kernelrelease)

echo "KERNELRELEASE=$KERNELRELEASE" >> ../.rpm-defs

cat > .kernel-binary.spec.buildenv <<EOF
# Override the timestamp 'uname -v' reports with the build
# timestamp.
export BUILD_TIMESTAMP="$(head -n 1 %_sourcedir/build-source-timestamp)"

# The following branch/timestamp will end up in Oopses.
export OOPS_TIMESTAMP="$(
    echo -n $(sed -nre 's/^(CVS|GIT) Branch: \(.*\)/\1-/p' \
		  %_sourcedir/build-source-timestamp)
    head -n 1 %_sourcedir/build-source-timestamp \
	| tr -dc 0-9)"

export KBUILD_VERBOSE=0
export KBUILD_SYMTYPES=1
export KBUILD_OVERRIDE=1
EOF
source .kernel-binary.spec.buildenv
make %{?jobs:-j%jobs} all $MAKE_ARGS

%install
source .rpm-defs

# get rid of /usr/lib/rpm/brp-strip-debug
# strip removes too much from the vmlinux ELF binary
export NO_BRP_STRIP_DEBUG=true

# /lib/modules/$KERNELRELEASE/build will be a stale symlink until the
# kernel-source package is installed. Don't check for stale symlinks
# in the brp-symlink check:
export NO_BRP_STALE_LINK_ERROR=yes

# skip long-running sanity checks
export NO_BRP_NOEXECSTACK=yes

cd linux-2.6.16

rm -rf %buildroot
mkdir -p %buildroot/boot
# (Could strip out non-public symbols.)
cp -p System.map %buildroot/boot/System.map-$KERNELRELEASE

add_vmlinux()
{
    local vmlinux=boot/vmlinux-$KERNELRELEASE
%if %{defined __debug_package}
    local vmlinux_debug=usr/lib/debug/$vmlinux.debug
    mkdir -p $(dirname %buildroot/$vmlinux_debug)
    cp vmlinux %buildroot/$vmlinux
    /usr/lib/rpm/debugedit -b %my_builddir -d /usr/src/debug \
			   -l vmlinux.sourcefiles %buildroot/$vmlinux
    objcopy --only-keep-debug \
	    %buildroot/$vmlinux \
	    %buildroot/$vmlinux_debug || :
    objcopy --add-gnu-debuglink=%buildroot/$vmlinux_debug \
	    --strip-debug \
	    %buildroot/$vmlinux || :
    mkdir -p %buildroot/usr/src/debug
    LANG=C sort -z -u vmlinux.sourcefiles \
    | (	cd %my_builddir
	cpio -pd0m %buildroot/usr/src/debug
    )
    chmod -R a+rX,go-w %buildroot/usr/src/debug
%else
    cp vmlinux %buildroot/$vmlinux
%endif
    if [ "$1" = --compressed ]; then
	gzip -9 %buildroot/$vmlinux
    fi
}

%if %build_kdump
    add_vmlinux
    chmod 644 %buildroot/boot/vmlinux-$KERNELRELEASE
    image=vmlinux
%else
%if %build_um
    add_vmlinux
    chmod 755 %buildroot/boot/vmlinux-$KERNELRELEASE
    image=vmlinux
%else
%ifarch %ix86 x86_64
    add_vmlinux --compressed
%if %build_xen
    image=vmlinuz
%else
    image=bzImage
%endif
    cp -p arch/*/boot/$image %buildroot/boot/vmlinuz-$KERNELRELEASE
    image=vmlinuz
%endif
%ifarch alpha
    add_vmlinux --compressed
    cp -p arch/alpha/boot/vmlinux.gz %buildroot/boot/vmlinuz-$KERNELRELEASE
    image=vmlinuz
%endif
%ifarch ppc ppc64
    add_vmlinux
    chmod 644 %buildroot/boot/vmlinux-$KERNELRELEASE
    image=vmlinux
%endif
%ifarch ia64
    add_vmlinux --compressed
    mv %buildroot/boot/vmlinux-$KERNELRELEASE.gz \
       %buildroot/boot/vmlinuz-$KERNELRELEASE
    image=vmlinuz
%endif
%ifarch s390 s390x
    add_vmlinux --compressed
    cp -p arch/s390/boot/image %buildroot/boot/image-$KERNELRELEASE
    image=image
%endif
    if [ -e init/kerntypes.o ]; then
	cp init/kerntypes.o %buildroot/boot/Kerntypes-$KERNELRELEASE
    fi
%endif
# kdump
%endif

(   cat %_sourcedir/functions.sh
    sed -e "s:@KERNELRELEASE@:$KERNELRELEASE:g" \
	-e "s:@IMAGE@:$image:g" \
	-e "s:@FLAVOR""@:iseries64:g" \
        %_sourcedir/pre.sh
) > ../pre.sh

(   cat %_sourcedir/functions.sh
    sed -e "s:@KERNELRELEASE@:$KERNELRELEASE:g" \
	-e "s:@IMAGE@:$image:g" \
	-e "s:@FLAVOR""@:iseries64:g" \
        %_sourcedir/post.sh
) > ../post.sh

(   cat %_sourcedir/functions.sh
    sed -e "s:@KERNELRELEASE@:$KERNELRELEASE:g" \
	-e "s:@IMAGE@:$image:g" \
	-e "s:@FLAVOR""@:iseries64:g" \
        %_sourcedir/postun.sh
) > ../postun.sh

%if %build_kdump || %build_um || %build_xen
suffix=-iseries64
%endif
ln -s $image$suffix %buildroot/boot/$image$suffix
ln -s initrd$suffix %buildroot/boot/initrd$suffix

cp .config %buildroot/boot/config-$KERNELRELEASE

make modules_install $MAKE_ARGS INSTALL_MOD_PATH=%buildroot

if ! %_sourcedir/check-supported-list \
	%_sourcedir %buildroot/lib/modules/$KERNELRELEASE; then
%if %supported_modules_check
    exit 1
%endif
    echo "Consistency check error: please update supported.conf."
fi

gzip -c9 < Module.symvers > %buildroot/boot/symvers-$KERNELRELEASE.gz

# Also put the resulting file in $obj_dir/$SUBARCH/iseries64
# so that kernel-source + kernel-iseries64 is sufficient for building
# modules that have modversions as well.
obj_dir=usr/src/linux-${KERNELRELEASE%%-iseries64}-obj
mkdir -p %buildroot/$obj_dir/$SUBARCH/iseries64
cp Module.symvers %buildroot/$obj_dir/$SUBARCH/iseries64

# Table of types used in exported symbols (for modversion debugging).
%_sourcedir/modversions --pack . > %buildroot/boot/symtypes-$KERNELRELEASE
if [ -s %buildroot/boot/symtypes-$KERNELRELEASE ]; then
    gzip -9 %buildroot/boot/symtypes-$KERNELRELEASE
else
    rm -f %buildroot/boot/symtypes-$KERNELRELEASE
fi

# Some architecture's $(uname -m) output is different from the ARCH
# parameter that needs to be passed to kbuild. Create symlinks from
# $(uname -m) to the ARCH directory.
[ -e %buildroot/$obj_dir/%_target_cpu ] \
    || ln -sf $SUBARCH %buildroot/$obj_dir/%_target_cpu
%ifarch ppc ppc64
[ -e %buildroot/$obj_dir/ppc ] \
    || ln -s $SUBARCH %buildroot/$obj_dir/ppc
[ -e %buildroot/$obj_dir/ppc64 ] \
    || ln -s $SUBARCH %buildroot/$obj_dir/ppc64
%endif

%ifarch %ix86 x86_64 ppc ppc64 ia64
%if "iseries64" == "default" || "iseries64" == "smp" || "iseries64" == "ppc64" || "iseries64" == "bigsmp" || "iseries64" == "xen" || "iseries64" == "xenpae"
%if 0%{?__debug_package:1}

#
# create configfile for makedumpfile utility (see makedumpfile(8)) to
# create smaller kdump images
CONFIGFILE=%buildroot/$obj_dir/$SUBARCH/iseries64/makedumpfile.config
makedumpfile -x vmlinux -g $CONFIGFILE

#
# fixup config file with current kernel version
if [ -f $CONFIGFILE ] ; then
    sed -i $CONFIGFILE -e "s/OSRELEASE=.*/OSRELEASE=$KERNELRELEASE/"

    # on IA64, we need to add the page size here -- that's the actual reason why
    # the makedumpfile tool relies on the running kernel and not on the compiled
    # kernel -- it's (nearly) impossible to get the page size of a vmlinux file.
%ifarch ia64
    if grep ^CONFIG_IA64_PAGE_SIZE_16KB .config >/dev/null ; then
        sed -i $CONFIGFILE -e "s/PAGESIZE=.*/PAGESIZE=16384/"
    elif grep ^CONFIG_IA64_PAGE_SIZE_64KB .config >/dev/null ; then
        sed -i $CONFIGFILE -e "s/PAGESIZE=.*/PAGESIZE=65536/"
    elif grep ^CONFIG_IA64_PAGE_SIZE_4KB  .config >/dev/null ; then
        sed -i $CONFIGFILE -e "s/PAGESIZE=.*/PAGESIZE=4096/"
    else
        sed -i $CONFIGFILE -e "s/PAGESIZE=.*/PAGESIZE=8192/"
    fi
%endif
%ifarch ppc64
    if grep ^CONFIG_PPC_64K_PAGES .config >/dev/null ; then
        sed -i $CONFIGFILE -e "s/PAGESIZE=.*/PAGESIZE=65536/"
    else
        sed -i $CONFIGFILE -e "s/PAGESIZE=.*/PAGESIZE=4096/"
    fi
%endif
fi
%endif
%endif
%endif

# generate symsets and check for kabi changes
symsets=%my_builddir/symsets-$KERNELRELEASE
mkdir -p $symsets
check_kabi=
if test -e %my_builddir/kabi/$SUBARCH/symsets-iseries64.tar.gz; then
    tar xzf %my_builddir/kabi/$SUBARCH/symsets-iseries64.tar.gz -C \
        %my_builddir/kabi/$SUBARCH
    check_kabi="--check-kabi
                --reference %my_builddir/kabi/$SUBARCH/symsets-*-iseries64/
	        --commonsyms=%my_builddir/kabi/commonsyms
	        --usedsyms=%my_builddir/kabi/usedsyms
	        --severities=%my_builddir/kabi/severities
	        --max-badness=%tolerate_kabi_changes"
fi
(   grep -v $'\tvmlinux$' Module.symvers
    # Find out in which built-in.o files the exported symbols that ended
    # up in vmlinux were defined.
    grep $'\tvmlinux$' Module.symvers | %_sourcedir/built-in-where
) > Module.symvers.annotated
find %buildroot/lib/modules -name '*.ko' >%my_builddir/modules
kabi=0
%_sourcedir/symsets.pl --generate-symsets \
    --columns=3 \
    $reference \
    --symvers=Module.symvers.annotated \
    --modules=%my_builddir/modules \
    --output-dir=$symsets \
    $check_kabi || kabi=$?
if [ $kabi -ne 0 ]; then
    # %ignore_kabi_badness is defined in the Kernel:* projects in the
    # OBS to be able to build the KOTD in spite of kabi errors
    if [ 0%{?ignore_kabi_badness} -eq 0 -a \
         ! -e %my_builddir/kabi/$SUBARCH/ignore-iseries64 -a \
         ! -e %_sourcedir/IGNORE-KABI-BADNESS ]; then
        echo "Create a file IGNORE-KABI-BADNESS in the kernel-source" \
             "directory to build this kernel even though its badness is" \
             "higher than allowed for an official kernel."
       exit 1
    fi
fi
tar czf %buildroot/boot/symsets-$KERNELRELEASE.tar.gz \
    -C ${symsets%/*} ${symsets##*/}

# We were building in %my_builddir/linux-2.6.16, but the sources will
# later be installed in /usr/src/linux-2.6.16-%release. Fix up the
# build symlink.
rm -f %buildroot/lib/modules/$KERNELRELEASE/{source,build}
ln -s /usr/src/linux-${KERNELRELEASE%%-iseries64} \
    %buildroot/lib/modules/$KERNELRELEASE/source
ln -s /$obj_dir/$SUBARCH/iseries64 \
    %buildroot/lib/modules/$KERNELRELEASE/build

# Abort if there are any undefined symbols
msg="$(/sbin/depmod -F %buildroot/boot/System.map-$KERNELRELEASE \
		    -b %buildroot -ae $KERNELRELEASE 2>&1)"
if [ $? -ne 0 ] || echo "$msg" | grep  'needs unknown symbol'; then
    exit 1
fi

# Create a dummy initrd with roughly the size the real one will have.
# That way, YaST will know that this package requires some additional
# space in /boot.
dd if=/dev/zero of=%buildroot/boot/initrd-$KERNELRELEASE \
    bs=1024 seek=2047 count=1

# Collect the file list.
(   cd %buildroot
    echo "%%defattr(-, root, root)"
    find boot \
	\( -type l -o -name 'initrd-*' \) -printf '%%%%ghost /%%p\n' -o \
	-type f -printf '/%%p\n'
    find lib/modules/$KERNELRELEASE \
	-type d -printf '%%%%dir /%%p\n' -o \
	-path '*/modules.*' -printf '%%%%ghost /%%p\n' -o \
	-printf '/%%p\n'
    find $obj_dir \
	-type d -printf '%%%%dir /%%p\n' -o \
	-printf '/%%p\n'
    echo '%%dir /etc/modprobe.d/'
    echo '%%config /etc/modprobe.d/module-renames'
    echo '%%config /etc/modprobe.d/generic_serial-blacklist'
%ifarch s390 s390x
    echo '%%config /etc/modprobe.d/qeth'
%endif
    if [ -e .%_docdir/%name ]; then
	echo "%%doc %_docdir/%name"
    fi
) > %my_builddir/kernel.files

# Set up some module aliases
install -d -m 755 %buildroot/etc/modprobe.d/
install -m 644 %_sourcedir/module-renames %buildroot/etc/modprobe.d/
install -m 644 %_sourcedir/generic_serial-blacklist %buildroot/etc/modprobe.d/
%ifarch s390 s390x
install -m 644 %_sourcedir/modprobe.d-qeth %buildroot/etc/modprobe.d/qeth
%endif

%pre -f pre.sh

%post -f post.sh

%postun -f postun.sh

%files -f kernel.files

%changelog
