#
# spec file for package kernel-syms
#
# Copyright (c) 2015 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           kernel-syms
%if ! 0%{?opensuse_bs}
BuildRequires:  kernel-dummy
%endif
%ifarch %ix86
BuildRequires:  kernel-bigsmp kernel-debug kernel-default kernel-kdump kernel-kdumppae kernel-smp kernel-vmi kernel-vmipae kernel-xen kernel-xenpae
%else
%ifarch ppc
BuildRequires:  kernel-default kernel-iseries64 kernel-kdump kernel-ppc64
%else
%ifarch ppc64
BuildRequires:  kernel-default kernel-iseries64 kernel-kdump kernel-ppc64
%else
%ifarch s390
BuildRequires:  kernel-s390
%else
%ifarch s390x
BuildRequires:  kernel-default
%else
%ifarch ia64
BuildRequires:  kernel-debug kernel-default
%else
%ifarch x86_64
BuildRequires:  kernel-debug kernel-default kernel-kdump kernel-smp kernel-xen
%else
%ifarch alpha
BuildRequires:  kernel-smp
%endif
%endif
%endif
%endif
%endif
%endif
%endif
%endif
# the packages above do require other things, but none of those are needed during package build
#!BuildIgnore: irqbalance xen
#!BuildIgnore: perl-Bootloader mkinitrd
License:        GPL
AutoReqProv:    off
Summary:        Kernel Symbol Versions (modversions)
Group:          Development/Sources
Version:        2.6.16.60
Release:        0.132.1
Requires:       linux
Requires:       kernel-source = 2.6.16.60-%release
Source11:       arch-symbols
Source12:       guards
Source21:       config.conf
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Prefix:         /usr/src

%(chmod +x %_sourcedir/{arch-symbols,guards})

%define preconf 1
%define symbols %(export PATCH_ARCH=%_target_cpu ; cd %_sourcedir ; set -- $(./arch-symbols) $([ -e extra-symbols ] && cat extra-symbols) ; echo $*)

%description
Kernel symbols, such as functions and variables, have version
information attached to them. This package contains the symbol versions
for the standard kernels.

Installing this package before compiling kernel modules outside of the
kernel source tree adds symbol version information to these modules.
Modules without symbol version information can only be loaded on the
exact kernel version for which they were compiled. Modules with symbol
version information can be loaded into more recent kernels as long as
none of the symbols exported by the kernel have changed. This provides
a reasonable level of confidence but does not guarantee that the module
will work.

Source Timestamp: 2015-03-05 10:07:41 +0100
GIT Revision: afc1df513f0e61aaa8885596b969636d882356c1
GIT Branch: SLES10-SP4-LTSS

%install
# skip long-running sanity checks
export NO_BRP_NOEXECSTACK=yes

rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT

%if %preconf
# Add all the symbol version hashes from the binary kernel packages
%_sourcedir/guards %symbols < %_sourcedir/series.conf \
    > %_builddir/kernel-source.patches
for config in $(%_sourcedir/guards %symbols < %_sourcedir/config.conf) ; do
    arch="${config%%/*}"
    flavor="${config#*/}"

    rpm -q --quiet kernel-$flavor || continue

    # Don't add the preconf files for kernels that are based
    # on a different set of patches than kernel-source.
    %_sourcedir/guards %symbols kernel-$flavor < %_sourcedir/series.conf \
	> %_builddir/kernel-$flavor.patches
    diff -q %_builddir/kernel-{source,$flavor}.patches || continue
    # Make sure that all the kernel-$flavor version-release match the
    # kernel-syms version-release.
    set -- %version-%release $(rpm -q --qf '%%{VERSION}-%%{RELEASE}' kernel-$flavor)
%if 0%{?opensuse_bs}
    set -- ${1%.*} ${2%.*}
%endif
    if [ "$1" != "$2" ]; then
	echo "version-release of %name-$1 and kernel-$flavor-$2 do not match" >&2
	exit 1
    fi

    shopt -s nullglob
    for symvers in /usr/src/linux-*-obj/$arch/*/Module.symvers; do
	mkdir -p $(dirname $RPM_BUILD_ROOT/$symvers)
	cp -p $symvers $RPM_BUILD_ROOT/$symvers
    done
    mkdir -p $RPM_BUILD_ROOT/boot
    for symsets in /boot/symsets-*-$flavor.tar.gz; do
	cp -p $symsets $RPM_BUILD_ROOT/boot
    done
done
%endif

%files
%defattr(-, root, root)
%if %preconf
/usr/src/linux-*-obj
%endif
/boot/symsets-*-*.tar.gz

%changelog
